import _typeof from 'babel-runtime/helpers/typeof';
import _JSON$stringify from 'babel-runtime/core-js/json/stringify';
import _Object$keys from 'babel-runtime/core-js/object/keys';
import util from '../util';

var isType = util.isType,
    isObject = util.isObject,
    isFunction = util.isFunction,
    CTS = util.CTS,
    deep = util.deep,
    isNil = util.isNil;
/**
 * [schemer 验证、重写、输出]
 * @param  {[type]} schema [数据模型]
 * @param  {[type]} real   [api返回数据]
 * @return {[type]}        [void]
 * TDDO::校验schema和真实数据，有差异记录、重写期望值
 *     
 */

export default schemer;
export { isMatch, compiler, creater, looper, schemer };
/**
 * [schemer 调起looper, 打印日志]
 * @param  {[type]} schema [description]
 * @param  {[type]} real   [description]
 * @param  {[type]} api    ['url']
 * @return {[type]}        [void]
 * 
 */
function schemer(schema, real, api) {
    var message = [];
    looper(schema, real, null, message);
    if (message.length) {
        // console.warn()
        console.group('\u63A5\u53E3\uFF1A' + api);
        message.forEach(function (item) {
            return console.warn(item);
        });
        console.groupEnd();
    }
}

function looper(schema, real, link, message) {
    link = link || [];
    _Object$keys(schema).forEach(function (key) {

        var schemaVal = schema[key];
        var realVal = real[key];
        link.push(key);

        if (Array.isArray(schemaVal)) {
            var schemaTpl = schemaVal[0];
            !Array.isArray(realVal) && (real[key] = creater(link, message, schemaVal));

            schemaTpl && real[key].forEach(function (item, index) {
                // console.log({item})

                link.push('&&[' + index + ']');

                if (isObject(schemaTpl)) {
                    looper(schemaTpl, item, link, message);
                } else {
                    real[key][index] = creater(link, message, schemaTpl, item);
                }
                link.pop();
            });
        } else if (isObject(schemaVal)) {

            !isObject(realVal) && (real[key] = creater(link, message, schemaVal));

            looper(schemaVal, real[key], link, message);
        } else {
            real[key] = creater(link, message, schemaVal, realVal);
        }
        link.pop();
    });
}

/**
 * [creater 数据生成器]
 * @param  {[type]} link    [description]
 * @param  {[type]} message [description]
 * @param  {[type]} type    [description]
 * @param  {[type]} val     [description]
 * @return {[type]}         [new-data]
 * TODO::收集不匹配提示
 */
function creater(link, message, schema, val) {
    var res = void 0;
    if (val && isMatch(schema, val)) {
        res = val;
    } else {
        var schemaType = compiler(schema, false, val);
        var schemaTypeStr = compiler(schema, true);

        if (Array.isArray(schema)) {
            res = [];
        } else if (isObject(schema)) {
            res = {};
        } else {
            res = schemaType;
        }

        var realType = isFunction(val) ? 'undefined' : val;
        var keyname = link.join('.').replace(/\.&&/g, '');
        var expecter = _JSON$stringify(schemaTypeStr);
        var resulter = _JSON$stringify(realType);
        var reseter = _JSON$stringify(res);
        var msg = '\u5B57\u6BB5 ' + keyname + ' : \u671F\u671B\u503C ' + expecter + ', \u8FD4\u56DE\u503C ' + resulter + ' => \u91CD\u5199\u4E3A\uFF1A' + reseter;

        message.push(msg);

        // console.log(JSON.stringify(res))
    }
    return res;
}

/**
 * [compiler 简单编译]
 * @param  {[type]} data    [数据源Data]
 * @param  {[type]} toType [转换为类型字符]
 * @return {[type]}        [new 数据Data]
 * 简单类型转换
 */
function compiler(schema, toType, real) {
    return deep(schema, function (item) {
        var res = void 0;
        switch (true) {
            case item === Number:
                res = toType ? 'Number' : isNaN(real) ? 0 : +real;
                break;
            case item === String:
                res = toType ? 'String' : isNil(real) ? '' : '' + real;
                break;
            case item === Boolean:
                res = toType ? 'Boolean' : false;
                break;
            case !!~['string', 'number', 'boolean'].indexOf(typeof real === 'undefined' ? 'undefined' : _typeof(real)):
                res = real;
                break;
            default:
                res = real && real.toString();
                break;
        }
        return res;
    });
}

/**
 * [isMatch 是否匹配类型]
 * @param  {[Class]} type [构造函数类型]
 * @param  {[string、number、boolean]} val  [属性值]
 * @return {[Boolean]}
 */
function isMatch(type, val) {
    return isType(CTS(type), val);
}