import _Object$keys from 'babel-runtime/core-js/object/keys';
import { isObject } from './lang.js';

/**
 * [deep json递归器]
 * @param  {[type]}   val [description]
 * @param  {Function} cb  [description]
 * @return {[type]}       [description]
 */
function deep(val, cb) {
    if (Array.isArray(val)) {
        return val.map(function (item) {
            return deep(item, cb);
        });
    } else if (isObject(val)) {
        return _Object$keys(val).reduce(function (pend, key) {
            pend[key] = deep(val[key], cb);
            return pend;
        }, {});
    } else {
        return cb(val);
    }
}

export default {
    deep: deep
};