import isNumber from 'lodash/isNumber';
import isString from 'lodash/isString';
import isBoolean from 'lodash/isBoolean';
import isUndefined from 'lodash/isUndefined';
import isNil from 'lodash/isNil';

var isType = function isType(type, obj) {
    return Object.prototype.toString.call(obj) == '[object ' + type + ']';
};
var isObject = function isObject(val) {
    return isType('Object', val);
};
var isFunction = function isFunction(val) {
    return isType('Function', val);
};

/**
 * [CTS 获取类型字符]
 * @param {[type]} constructor [Class]
 * String => 'String'
 * Number => 'Number'
 * ...Class => 'Class'
 * OR Function.name
 */
function CTS(constructor) {
    constructor = constructor || '';
    return ['Number', 'String', 'Boolean', 'Object', 'Array'].filter(function (type) {
        return ~constructor.toString().indexOf(type);
    })[0];
}

export { isUndefined, isBoolean, isType, isObject, isFunction, isNil, CTS };